﻿using CallCenter.Caches;
using CallCenter.Realtimes;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenter.CacheManager
{
    public class CallQueueManager : BackgroundService
    {
        private readonly IServiceScopeFactory _serviceScopeFactory;

        public CallQueueManager(IServiceScopeFactory serviceScopeFactory)
        {
            _serviceScopeFactory = serviceScopeFactory;
        }


        protected override async Task ExecuteAsync(CancellationToken cancellationToken)
        {
            //work缓存注入
            var userCacheManager = _serviceScopeFactory.CreateScope().ServiceProvider.GetService<IUserCacheManager>();
            //消息通知注入
            var realtimeService = _serviceScopeFactory.CreateScope().ServiceProvider.GetService<IRealtimeService>();

            var time = TimeSpan.FromSeconds(1);
            while (!cancellationToken.IsCancellationRequested)
            {
                //通知
                await realtimeService.CallQueueAsync(cancellationToken);
                await Task.Delay(time, cancellationToken);
            }

            
        }
    }
}
